/** @file cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef CMDLINE_H
#define CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define CMDLINE_PARSER_PACKAGE "barriers"
#endif

#ifndef CMDLINE_PARSER_VERSION
/** @brief the program version */
#define CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *full_help_help; /**< @brief Print help, including hidden options, and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int quiet_flag;	/**< @brief be quiet, inhibit PS output (default=off).  */
  const char *quiet_help; /**< @brief be quiet, inhibit PS output help description.  */
  int verbose_flag;	/**< @brief print more information (default=off).  */
  const char *verbose_help; /**< @brief print more information help description.  */
  char * graph_arg;	/**< @brief define graph type (default='RNA').  */
  char * graph_orig;	/**< @brief define graph type original value given at command line.  */
  const char *graph_help; /**< @brief define graph type help description.  */
  char * moves_arg;	/**< @brief select move-set (if Graph allows several different ones).  */
  char * moves_orig;	/**< @brief select move-set (if Graph allows several different ones) original value given at command line.  */
  const char *moves_help; /**< @brief select move-set (if Graph allows several different ones) help description.  */
  int bsize_flag;	/**< @brief print basin sizes (default=off).  */
  const char *bsize_help; /**< @brief print basin sizes help description.  */
  int ssize_flag;	/**< @brief print saddle component sizes (default=off).  */
  const char *ssize_help; /**< @brief print saddle component sizes help description.  */
  int max_arg;	/**< @brief compute only the lowest <num> local minima (default='100').  */
  char * max_orig;	/**< @brief compute only the lowest <num> local minima original value given at command line.  */
  const char *max_help; /**< @brief compute only the lowest <num> local minima help description.  */
  double minh_arg;	/**< @brief print only minima with barrier > dE (default='0.000001').  */
  char * minh_orig;	/**< @brief print only minima with barrier > dE original value given at command line.  */
  const char *minh_help; /**< @brief print only minima with barrier > dE help description.  */
  int saddle_flag;	/**< @brief print saddle point structures (default=off).  */
  const char *saddle_help; /**< @brief print saddle point structures help description.  */
  int rates_flag;	/**< @brief compute rates between macro states (basins) (default=off).  */
  const char *rates_help; /**< @brief compute rates between macro states (basins) help description.  */
  int microrates_flag;	/**< @brief compute microscopic rates between connected states (default=off).  */
  const char *microrates_help; /**< @brief compute microscopic rates between connected states help description.  */
  int poset_arg;	/**< @brief input is a poset from n objective functions (default='0').  */
  char * poset_orig;	/**< @brief input is a poset from n objective functions original value given at command line.  */
  const char *poset_help; /**< @brief input is a poset from n objective functions help description.  */
  char ** path_arg;	/**< @brief backtrack path between lmins l2 and l1 (l1 < l2),       can be specified multiple times.  */
  char ** path_orig;	/**< @brief backtrack path between lmins l2 and l1 (l1 < l2),       can be specified multiple times original value given at command line.  */
  unsigned int path_min; /**< @brief backtrack path between lmins l2 and l1 (l1 < l2),       can be specified multiple times's minimum occurreces */
  unsigned int path_max; /**< @brief backtrack path between lmins l2 and l1 (l1 < l2),       can be specified multiple times's maximum occurreces */
  const char *path_help; /**< @brief backtrack path between lmins l2 and l1 (l1 < l2),       can be specified multiple times help description.  */
  double temp_arg;	/**< @brief temperature for Boltzmann factor.  */
  char * temp_orig;	/**< @brief temperature for Boltzmann factor original value given at command line.  */
  const char *temp_help; /**< @brief temperature for Boltzmann factor help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int full_help_given ;	/**< @brief Whether full-help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int quiet_given ;	/**< @brief Whether quiet was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */
  unsigned int graph_given ;	/**< @brief Whether graph was given.  */
  unsigned int moves_given ;	/**< @brief Whether moves was given.  */
  unsigned int bsize_given ;	/**< @brief Whether bsize was given.  */
  unsigned int ssize_given ;	/**< @brief Whether ssize was given.  */
  unsigned int max_given ;	/**< @brief Whether max was given.  */
  unsigned int minh_given ;	/**< @brief Whether minh was given.  */
  unsigned int saddle_given ;	/**< @brief Whether saddle was given.  */
  unsigned int rates_given ;	/**< @brief Whether rates was given.  */
  unsigned int microrates_given ;	/**< @brief Whether microrates was given.  */
  unsigned int poset_given ;	/**< @brief Whether poset was given.  */
  unsigned int path_given ;	/**< @brief Whether path was given.  */
  unsigned int temp_given ;	/**< @brief Whether temp was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];
/** @brief all the lines making the full help output (including hidden options) */
extern const char *gengetopt_args_info_full_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser (int argc, char * const *argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use cmdline_parser_ext() instead
 */
int cmdline_parser2 (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_ext (int argc, char * const *argv,
  struct gengetopt_args_info *args_info,
  struct cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int cmdline_parser_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void cmdline_parser_print_help(void);
/**
 * Print the full help (including hidden options)
 */
void cmdline_parser_print_full_help(void);
/**
 * Print the version
 */
void cmdline_parser_print_version(void);

/**
 * Initializes all the fields a cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void cmdline_parser_params_init(struct cmdline_parser_params *params);

/**
 * Allocates dynamically a cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized cmdline_parser_params structure
 */
struct cmdline_parser_params *cmdline_parser_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void cmdline_parser_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void cmdline_parser_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int cmdline_parser_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* CMDLINE_H */
